'From Squeak3.8 of ''5 May 2005'' [latest update: #6665] on 29 October 2005 at 9:17:04 pm'!
ObjectMemory subclass: #Interpreter
	instanceVariableNames: 'activeContext theHomeContext method receiver instructionPointer stackPointer localIP localSP localHomeContext localReturnContext localReturnValue messageSelector argumentCount newMethod currentBytecode successFlag primitiveIndex primitiveFunctionPointer methodCache atCache lkupClass reclaimableContextCount nextPollTick nextWakeupTick lastTick interruptKeycode interruptPending semaphoresToSignalA semaphoresUseBufferA semaphoresToSignalCountA semaphoresToSignalB semaphoresToSignalCountB processSignalingLowSpace savedWindowSize fullScreenFlag deferDisplayUpdates pendingFinalizationSignals compilerInitialized compilerHooks extraVMMemory newNativeMethod methodClass receiverClass interpreterVersion obsoleteIndexedPrimitiveTable obsoleteNamedPrimitiveTable interpreterProxy showSurfaceFn interruptCheckCounterFeedBackReset interruptChecksEveryNms externalPrimitiveTable primitiveTable globalSessionID vmStatsTraceMessageSendStorageFile vmStatsTraceMessageSendLevels '
	classVariableNames: 'ActiveProcessIndex AtCacheEntries AtCacheFixedFields AtCacheFmt AtCacheMask AtCacheOop AtCacheSize AtCacheTotalSize AtPutBase BlockArgumentCountIndex BlockMethodIndex BytecodeTable CacheProbeMax CallerIndex CharacterValueIndex CompilerHooksSize CrossedX DirBadPath DirEntryFound DirNoMoreEntries EndOfRun ExcessSignalsIndex FirstLinkIndex HeaderIndex HomeIndex InitialIPIndex InstanceSpecificationIndex InstructionPointerIndex JitterTable LastLinkIndex LiteralStart MaxExternalPrimitiveTableSize MaxPrimitiveIndex MessageArgumentsIndex MessageDictionaryIndex MessageLookupClassIndex MessageSelectorIndex MethodArrayIndex MethodCacheClass MethodCacheEntries MethodCacheEntrySize MethodCacheMask MethodCacheMethod MethodCacheNative MethodCachePrim MethodCachePrimFunction MethodCacheSelector MethodCacheSize MethodIndex MillisecondClockMask MyListIndex NextLinkIndex PrimitiveExternalCallIndex PrimitiveTable PriorityIndex ProcessListsIndex ReceiverIndex SelectorStart SemaphoresToSignalSize SenderIndex StackPointerIndex StreamArrayIndex StreamIndexIndex StreamReadLimitIndex StreamWriteLimitIndex SuperclassIndex SuspendedContextIndex TempFrameStart ValueIndex XIndex YIndex '
	poolDictionaries: ''
	category: 'VMMaker-Interpreter'!

!Interpreter methodsFor: 'message sending' stamp: 'JMM 10/29/2005 13:13'!
commonSend
	"Send a message, starting lookup with the receiver's class."
	"Assume: messageSelector and argumentCount have been set, and that 
	the receiver and arguments have been pushed onto the stack,"
	"Note: This method is inlined into the interpreter dispatch loop."
	self sharedCodeNamed: 'commonSend' inCase: 131.
	self internalFindNewMethod.
	self internalExecuteNewMethod.
	vmStatsTraceMessageSendLevels = 0 ifFalse: [self printCallStack1OnlyOf: activeContext].
	self fetchNextBytecode! !

!Interpreter methodsFor: 'debug printing' stamp: 'JMM 10/29/2005 16:56'!
printCallStack1OnlyOf: aContext

	| ctxt home methClass methodSel message  counter proc |
	self inline: false.
	vmStatsTraceMessageSendStorageFile = 0 ifTrue: [self cCode: 'foo->vmStatsTraceMessageSendStorageFile = fopen("./messageTraceFile.txt","w+b")'].
	
	ctxt := aContext.
	counter := 0.
	[ctxt = nilObj] whileFalse: [
		counter := counter + 1.
		counter > vmStatsTraceMessageSendLevels ifTrue: 
			[vmStatsTraceMessageSendLevels > 1
				 ifTrue: [self print: '\n' toStorageFile: vmStatsTraceMessageSendStorageFile].
			self cCode: 'return' inSmalltalk: [^self]].
		(self fetchClassOf: ctxt) = (self splObj: ClassBlockContext)
			ifTrue: [ home := self fetchPointer: HomeIndex ofObject: ctxt ]
			ifFalse: [ home := ctxt ].
		methClass :=
			self findClassOfMethod: (self fetchPointer: MethodIndex ofObject: home)
					   forReceiver: (self fetchPointer: ReceiverIndex ofObject: home).
		methodSel :=
			self findSelectorOfMethod: (self fetchPointer: MethodIndex ofObject: home)
						 forReceiver: (self fetchPointer: ReceiverIndex ofObject: home).

		proc := self fetchPointer: ActiveProcessIndex ofObject: self schedulerPointer.
		self printNum: proc toStorageFile: vmStatsTraceMessageSendStorageFile.
		self print: ' ' toStorageFile: vmStatsTraceMessageSendStorageFile.
		self printNum: ctxt toStorageFile: vmStatsTraceMessageSendStorageFile.
		self print: ' ' toStorageFile: vmStatsTraceMessageSendStorageFile.
		self printNum: statIncrGCs toStorageFile: vmStatsTraceMessageSendStorageFile.
		self print: ' ' toStorageFile: vmStatsTraceMessageSendStorageFile.
		ctxt = home ifFalse: [ self print: '[] in ' toStorageFile: vmStatsTraceMessageSendStorageFile ].
		self printNameOfClass: methClass count: 5 toStorageFile: vmStatsTraceMessageSendStorageFile.
		self print: '>' toStorageFile: vmStatsTraceMessageSendStorageFile.
		methodSel = nilObj
			ifTrue: [self print: '?' toStorageFile: vmStatsTraceMessageSendStorageFile]
			ifFalse: [self printStringOf: methodSel toStorageFile: vmStatsTraceMessageSendStorageFile].
		methodSel = (self splObj: SelectorDoesNotUnderstand) ifTrue: [
			"print arg message selector"
			message := self fetchPointer: 0 + TempFrameStart ofObject: home.
			methodSel := self fetchPointer: MessageSelectorIndex ofObject: message.
			self print: ' ' toStorageFile: vmStatsTraceMessageSendStorageFile.
			self printStringOf: methodSel toStorageFile: vmStatsTraceMessageSendStorageFile.
		].
		self print: '\n' toStorageFile: vmStatsTraceMessageSendStorageFile..

		ctxt := (self fetchPointer: SenderIndex ofObject: ctxt).
	].
	vmStatsTraceMessageSendLevels > 1
		ifTrue: [self print: '\n' toStorageFile: vmStatsTraceMessageSendStorageFile].
! !

!Interpreter methodsFor: 'debug printing' stamp: 'JMM 10/29/2005 16:46'!
printChar: aByte toStorageFile: storageFile
	self var: #storageFile declareC: 'FILE *storageFile'.
	storageFile = 0 ifFalse: [self cCode: 'fprintf(storageFile,"%c", aByte)'.].
	! !

!Interpreter methodsFor: 'debug printing' stamp: 'JMM 10/28/2005 22:18'!
printNameOfClass: classOop count: cnt toStorageFile: storageFile
	"Details: The count argument is used to avoid a possible infinite recursion if classOop is a corrupted object."

	self inline: true..
	self var: #storageFile declareC: 'FILE *storageFile'.
	cnt <= 0 ifTrue: [ ^ self print: 'bad class' toStorageFile: storageFile].
	(self sizeBitsOf: classOop) = (7 * BytesPerWord)	"(Metaclass instSize+1 * 4)"
		ifTrue: [self printNameOfClass: (self fetchPointer: 5 "thisClass" ofObject: classOop) 
					count: cnt - 1 toStorageFile: storageFile.
				self print: ' class' toStorageFile: storageFile]
	ifFalse: [self printStringOf: (self fetchPointer: 6 "name" ofObject: classOop) toStorageFile: storageFile]! !

!Interpreter methodsFor: 'debug printing' stamp: 'JMM 10/29/2005 16:46'!
printNum: n toStorageFile: storageFile
	"For testing in Smalltalk, this method should be overridden in a subclass."

	self inline: true..
	self var: #storageFile declareC: 'FILE *storageFile'.
	storageFile = 0 ifFalse: [self cCode: 'fprintf(storageFile,"%ld", (long) n)'.].
	! !

!Interpreter methodsFor: 'debug printing' stamp: 'JMM 10/28/2005 21:42'!
printStringOf: oop toStorageFile: storageFile

	| fmt cnt i |
	self inline: true..
	self var: #storageFile declareC: 'FILE *storageFile'.
	(self isIntegerObject: oop) ifTrue:[^nil].
	fmt := self formatOf: oop.
	fmt < 8 ifTrue: [ ^nil ].

	cnt := 100 min: (self lengthOf: oop).
	i := 0.
	[i < cnt] whileTrue: [
		self printChar: (self fetchByte: i ofObject: oop) toStorageFile: storageFile.
		i := i + 1.
	].! !

!Interpreter methodsFor: 'debug printing' stamp: 'JMM 10/29/2005 16:47'!
print: s toStorageFile: storageFile
	"For testing in Smalltalk, this method should be overridden in a subclass."

	self inline: true..
	self var: #storageFile declareC: 'FILE *storageFile'.
	self var: #s declareC: 'char *s'.
	storageFile = 0 ifFalse: [self cCode: 'fprintf(storageFile,"%s", s)'.].
	! !

!Interpreter methodsFor: 'initialization' stamp: 'JMM 10/29/2005 13:17'!
initializeInterpreter: bytesToShift 
	"Initialize Interpreter state before starting execution of a new image."
	interpreterProxy := self sqGetInterpreterProxy.
	self dummyReferToProxy.
	self initializeObjectMemory: bytesToShift.
	self initCompilerHooks.
	activeContext := nilObj.
	theHomeContext := nilObj.
	method := nilObj.
	receiver := nilObj.
	messageSelector := nilObj.
	newMethod := nilObj.
	methodClass := nilObj.
	lkupClass := nilObj.
	receiverClass := nilObj.
	newNativeMethod := nilObj.
	self flushMethodCache.
	self loadInitialContext.
	self initialCleanup.
	interruptCheckCounter := 0.
	interruptCheckCounterFeedBackReset := 1000.
	interruptChecksEveryNms := 1.
	nextPollTick := 0.
	nextWakeupTick := 0.
	lastTick := 0.
	interruptKeycode := 2094. "cmd-. as used for Mac but no other OS"
	interruptPending := false.
	semaphoresUseBufferA := true.
	semaphoresToSignalCountA := 0.
	semaphoresToSignalCountB := 0.
	deferDisplayUpdates := false.
	pendingFinalizationSignals := 0.
	self initVmStatsTraceMessageSendLevels.
	globalSessionID := 0.
	[globalSessionID = 0]
		whileTrue: [globalSessionID := self
						cCode: 'time(NULL) + ioMSecs()'
						inSmalltalk: [(Random new next * SmallInteger maxVal) asInteger]]! !

!Interpreter methodsFor: 'initialization' stamp: 'JMM 10/29/2005 16:33'!
initVmStatsTraceMessageSendLevels
	vmStatsTraceMessageSendLevels := 0.
 	vmStatsTraceMessageSendStorageFile := 0.
	self cCode: ' {
  void handleUSR1(int signal);
  void handleUSR2(int signal);

  signal(SIGUSR1, handleUSR1);
  signal(SIGUSR2, handleUSR2);
  }
}
#include <libc.h>
#include <signal.h>

void handleUSR1(int signal) {
  foo->vmStatsTraceMessageSendLevels++;
}

void handleUSR2(int signal) {
  foo->vmStatsTraceMessageSendLevels = 0;
  if (foo->vmStatsTraceMessageSendStorageFile)
	fclose(foo->vmStatsTraceMessageSendStorageFile);
  foo->vmStatsTraceMessageSendStorageFile = 0;

'

! !

!Interpreter methodsFor: 'memory space primitives' stamp: 'JMM 10/29/2005 16:16'!
primitiveSetVMStatsTraceMessageSendLevels
	"Primitive. Indicate if the VM should trace message sends"
	| value |
	self export: true.
	value := self stackIntegerValue: 0.
	successFlag ifTrue:[
		vmStatsTraceMessageSendLevels := value.
		vmStatsTraceMessageSendLevels = 0 ifTrue: 
			[vmStatsTraceMessageSendStorageFile = 0 ifFalse: [self fclose: vmStatsTraceMessageSendStorageFile].
			vmStatsTraceMessageSendStorageFile = 0].
		self pop: argumentCount.
	].! !


!Interpreter class methodsFor: 'translation' stamp: 'JMM 10/29/2005 16:46'!
declareCVarsIn: aCCodeGenerator

	aCCodeGenerator 
		var: #interpreterProxy 
		type: #'struct VirtualMachine*'.
	aCCodeGenerator
		var: #primitiveTable
		declareC: 'void *primitiveTable[', (MaxPrimitiveIndex +2) printString, '] = ',	self primitiveTableString.
	aCCodeGenerator
		var: #primitiveFunctionPointer
		declareC: 'void *primitiveFunctionPointer'				.		"xxxx FIX THIS STUPIDITY xxxx - ikp. What he means is use a better type than void *, apparently - tpr"
	aCCodeGenerator
		var: #methodCache
		declareC: 'long methodCache[', (MethodCacheSize + 1) printString, ']'.
	aCCodeGenerator
		var: #atCache
		declareC: 'sqInt atCache[', (AtCacheTotalSize + 1) printString, ']'.
	aCCodeGenerator var: #localIP type: #'char*'.
	aCCodeGenerator var: #localSP type: #'char*'.
	aCCodeGenerator var: #showSurfaceFn type: #'void*'.
	aCCodeGenerator var: 'semaphoresToSignalA'
		declareC: 'sqInt semaphoresToSignalA[', (SemaphoresToSignalSize + 1) printString, ']'.
	aCCodeGenerator var: 'semaphoresToSignalB'
		declareC: 'sqInt semaphoresToSignalB[', (SemaphoresToSignalSize + 1) printString, ']'.
	aCCodeGenerator
		var: #compilerHooks
		declareC: 'sqInt (*compilerHooks[', (CompilerHooksSize + 1) printString, '])()'.
	aCCodeGenerator
		var: #interpreterVersion
		declareC: 'const char *interpreterVersion = "', SmalltalkImage current datedVersion, ' [', SmalltalkImage current lastUpdateString,']"'.
	aCCodeGenerator
		var: #obsoleteIndexedPrimitiveTable
		declareC: 'char* obsoleteIndexedPrimitiveTable[][3] = ', self obsoleteIndexedPrimitiveTableString.
	aCCodeGenerator
		var: #obsoleteNamedPrimitiveTable
		declareC: 'const char* obsoleteNamedPrimitiveTable[][3] = ', self obsoleteNamedPrimitiveTableString.
	aCCodeGenerator
		var: #externalPrimitiveTable
		declareC: 'void *externalPrimitiveTable[', (MaxExternalPrimitiveTableSize + 1) printString, ']'.
	aCCodeGenerator
		var: #vmStatsTraceMessageSendStorageFile
		declareC: 'FILE *vmStatsTraceMessageSendStorageFile'.! !

ObjectMemory subclass: #Interpreter
	instanceVariableNames: 'activeContext theHomeContext method receiver instructionPointer stackPointer localIP localSP localHomeContext localReturnContext localReturnValue messageSelector argumentCount newMethod currentBytecode successFlag primitiveIndex primitiveFunctionPointer methodCache atCache lkupClass reclaimableContextCount nextPollTick nextWakeupTick lastTick interruptKeycode interruptPending semaphoresToSignalA semaphoresUseBufferA semaphoresToSignalCountA semaphoresToSignalB semaphoresToSignalCountB processSignalingLowSpace savedWindowSize fullScreenFlag deferDisplayUpdates pendingFinalizationSignals compilerInitialized compilerHooks extraVMMemory newNativeMethod methodClass receiverClass interpreterVersion obsoleteIndexedPrimitiveTable obsoleteNamedPrimitiveTable interpreterProxy showSurfaceFn interruptCheckCounterFeedBackReset interruptChecksEveryNms externalPrimitiveTable primitiveTable globalSessionID vmStatsTraceMessageSendLevels vmStatsTraceMessageSendStorageFile'
	classVariableNames: 'ActiveProcessIndex AtCacheEntries AtCacheFixedFields AtCacheFmt AtCacheMask AtCacheOop AtCacheSize AtCacheTotalSize AtPutBase BlockArgumentCountIndex BlockMethodIndex BytecodeTable CacheProbeMax CallerIndex CharacterValueIndex CompilerHooksSize CrossedX DirBadPath DirEntryFound DirNoMoreEntries EndOfRun ExcessSignalsIndex FirstLinkIndex HeaderIndex HomeIndex InitialIPIndex InstanceSpecificationIndex InstructionPointerIndex JitterTable LastLinkIndex LiteralStart MaxExternalPrimitiveTableSize MaxPrimitiveIndex MessageArgumentsIndex MessageDictionaryIndex MessageLookupClassIndex MessageSelectorIndex MethodArrayIndex MethodCacheClass MethodCacheEntries MethodCacheEntrySize MethodCacheMask MethodCacheMethod MethodCacheNative MethodCachePrim MethodCachePrimFunction MethodCacheSelector MethodCacheSize MethodIndex MillisecondClockMask MyListIndex NextLinkIndex PrimitiveExternalCallIndex PrimitiveTable PriorityIndex ProcessListsIndex ReceiverIndex SelectorStart SemaphoresToSignalSize SenderIndex StackPointerIndex StreamArrayIndex StreamIndexIndex StreamReadLimitIndex StreamWriteLimitIndex SuperclassIndex SuspendedContextIndex TempFrameStart ValueIndex XIndex YIndex'
	poolDictionaries: ''
	category: 'VMMaker-Interpreter'!
